JavaScript/jQuery Chart - ArrayStore

If you want to extend the functionality of a JavaScript array, place it into an ArrayStore. It provides an interface for loading and editing data, and allows you to handle data-related events.

index.js
  • const fruits = [
  • { fruit: 'Apples', count: 10 },
  • { fruit: 'Oranges', count: 12 },
  • { fruit: 'Lemons', count: 15 },
  • { fruit: 'Pears', count: 20 },
  • { fruit: 'Pineapples', count: 3 }
  • ];
  •  
  • $(function() {
  • $("#chartContainer").dxChart({
  • dataSource: new DevExpress.data.DataSource({
  • store: {
  • type: 'array',
  • data: fruits,
  • onLoaded: function () {
  • // Event handling commands go here
  • }
  • },
  • paginate: false
  • }),
  • series: {
  • argumentField: 'fruit',
  • valueField: 'count'
  • }
  • });
  • });

As you may notice, in the previous code, the ArrayStore is not declared explicilty. Instead, it is wrapped in the DataSource instance. That is because the Chart requires pagination to be off in order to prevent data from partitioning. Other than that, the DataSource provides wide data-processing capabilities. For example, it can map objects from the array that underlies the ArrayStore, as shown in the following code.

index.js
  • const fruits = [
  • { apples: 10 },
  • { oranges: 12 },
  • { lemons: 15 },
  • { pears: 20 },
  • { pineapples: 3 }
  • ];
  •  
  • $(function() {
  • $("#chartContainer").dxChart({
  • dataSource: new DevExpress.data.DataSource({
  • store: {
  • type: 'array',
  • data: fruits
  • },
  • map: function (item) {
  • const fruitName = Object.keys(item)[0];
  • return {
  • fruit: fruitName.charAt(0).toUpperCase() + fruitName.slice(1),
  • count: item[fruitName]
  • }
  • },
  • paginate: false
  • }),
  • series: {
  • argumentField: 'fruit',
  • valueField: 'count'
  • }
  • });
  • });
NOTE
Even if you have passed a JavaScript array to the dataSource property, the Chart automatically places it into an ArrayStore wrapped into the DataSource that you can get with the getDataSource() method.
See Also

Vue Chart - ArrayStore

If you want to extend the functionality of a JavaScript array, place it into an ArrayStore. It provides an interface for loading and editing data, and allows you to handle data-related events.

App.vue
  • <template>
  • <DxChart :data-source="chartDataSource">
  • <DxSeries argument-field="fruit" value-field="count" />
  • </DxChart>
  • </template>
  •  
  • <script>
  • import DxChart, {
  • DxSeries
  • } from 'devextreme-vue/chart';
  • import DataSource from 'devextreme/data/data_source';
  •  
  • const fruits = [
  • { fruit: 'Apples', count: 10 },
  • { fruit: 'Oranges', count: 12 },
  • { fruit: 'Lemons', count: 15 },
  • { fruit: 'Pears', count: 20 },
  • { fruit: 'Pineapples', count: 3 }
  • ];
  •  
  • const chartDataSource = new DataSource({
  • store: {
  • type: 'array',
  • data: fruits,
  • onLoaded: function () {
  • // Event handling commands go here
  • }
  • },
  • paginate: false
  • });
  •  
  • export default {
  • components: {
  • DxChart,
  • DxSeries
  • },
  • data() {
  • return {
  • chartDataSource
  • }
  • }
  • }
  • </script>

As you may notice, in the previous code, the ArrayStore is not declared explicilty. Instead, it is wrapped in the DataSource instance. That is because the Chart requires pagination to be off in order to prevent data from partitioning. Other than that, the DataSource provides wide data-processing capabilities. For example, it can map objects from the array that underlies the ArrayStore, as shown in the following code.

App.vue
  • <template>
  • <DxChart :data-source="chartDataSource">
  • <DxSeries argument-field="fruit" value-field="count" />
  • </DxChart>
  • </template>
  •  
  • <script>
  • import DxChart, {
  • DxSeries
  • } from 'devextreme-vue/chart';
  • import DataSource from 'devextreme/data/data_source';
  •  
  • const fruits = [
  • { apples: 10 },
  • { oranges: 12 },
  • { lemons: 15 },
  • { pears: 20 },
  • { pineapples: 3 }
  • ];
  •  
  • const chartDataSource = new DataSource({
  • store: {
  • type: 'array',
  • data: fruits
  • },
  • map: function (item) {
  • const fruitName = Object.keys(item)[0];
  • return {
  • fruit: fruitName.charAt(0).toUpperCase() + fruitName.slice(1),
  • count: item[fruitName]
  • }
  • },
  • paginate: false
  • });
  •  
  • export default {
  • components: {
  • DxChart,
  • DxSeries
  • },
  • data() {
  • return {
  • chartDataSource
  • }
  • }
  • }
  • </script>
NOTE
Even if you have passed a JavaScript array to the dataSource property, the Chart automatically places it into an ArrayStore wrapped into the DataSource that you can get with the getDataSource() method.
See Also

Angular Chart - ArrayStore
If you want to extend the functionality of a JavaScript array, place it into an ArrayStore. It provides an interface for loading and editing data, and allows you to handle data-related events.
jQuery
const fruits = [
{ fruit: 'Apples', count: 10 },
{ fruit: 'Oranges', count: 12 },
{ fruit: 'Lemons', count: 15 },
{ fruit: 'Pears', count: 20 },
{ fruit: 'Pineapples', count: 3 }
];
$(function() {
$("#chartContainer").dxChart({
dataSource: new DevExpress.data.DataSource({
store: {
type: 'array',
data: fruits,
onLoaded: function () {
// Event handling commands go here
}
},
paginate: false
}),
series: {
argumentField: 'fruit',
valueField: 'count'
}
});
});Angular
import { Component } from '@angular/core';
import DataSource from 'devextreme/data/data_source';
@Component({
selector: 'app-root',
templateUrl: './app.component.html',
styleUrls: ['./app.component.css']
})
export class AppComponent {
fruits = [
{ fruit: 'Apples', count: 10 },
{ fruit: 'Oranges', count: 12 },
{ fruit: 'Lemons', count: 15 },
{ fruit: 'Pears', count: 20 },
{ fruit: 'Pineapples', count: 3 }
];
chartDataSource = new DataSource({
store: {
type: 'array',
data: this.fruits,
onLoaded: function () {
// Event handling commands go here
}
},
paginate: false
});
}
<dx-chart [dataSource]="chartDataSource">
<dxi-series argumentField="fruit" valueField="count"></dxi-series>
</dx-chart>
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { AppComponent } from './app.component';
import { DxChartModule } from 'devextreme-angular';
@NgModule({
declarations: [
AppComponent
],
imports: [
BrowserModule,
DxChartModule
],
providers: [ ],
bootstrap: [AppComponent]
})
export class AppModule { }Vue
<template>
<DxChart :data-source="chartDataSource">
<DxSeries argument-field="fruit" value-field="count" />
</DxChart>
</template>
<script>
import DxChart, {
DxSeries
} from 'devextreme-vue/chart';
import DataSource from 'devextreme/data/data_source';
const fruits = [
{ fruit: 'Apples', count: 10 },
{ fruit: 'Oranges', count: 12 },
{ fruit: 'Lemons', count: 15 },
{ fruit: 'Pears', count: 20 },
{ fruit: 'Pineapples', count: 3 }
];
const chartDataSource = new DataSource({
store: {
type: 'array',
data: fruits,
onLoaded: function () {
// Event handling commands go here
}
},
paginate: false
});
export default {
components: {
DxChart,
DxSeries
},
data() {
return {
chartDataSource
}
}
}
</script>React
import Chart, {
Series
} from 'devextreme-react/chart';
import DataSource from 'devextreme/data/data_source';
const fruits = [
{ fruit: 'Apples', count: 10 },
{ fruit: 'Oranges', count: 12 },
{ fruit: 'Lemons', count: 15 },
{ fruit: 'Pears', count: 20 },
{ fruit: 'Pineapples', count: 3 }
];
const chartDataSource = new DataSource({
store: {
type: 'array',
data: fruits,
onLoaded: function () {
// Event handling commands go here
}
},
paginate: false
});
export default function App() {
return (
<Chart dataSource={chartDataSource}>
<Series argumentField="fruit" valueField="count" />
</Chart>
);
}As you may notice, in the previous code, the ArrayStore is not declared explicilty. Instead, it is wrapped in the DataSource instance. That is because the Chart requires pagination to be off in order to prevent data from partitioning. Other than that, the DataSource provides wide data-processing capabilities. For example, it can map objects from the array that underlies the ArrayStore, as shown in the following code.
jQuery
const fruits = [
{ apples: 10 },
{ oranges: 12 },
{ lemons: 15 },
{ pears: 20 },
{ pineapples: 3 }
];
$(function() {
$("#chartContainer").dxChart({
dataSource: new DevExpress.data.DataSource({
store: {
type: 'array',
data: fruits
},
map: function (item) {
const fruitName = Object.keys(item)[0];
return {
fruit: fruitName.charAt(0).toUpperCase() + fruitName.slice(1),
count: item[fruitName]
}
},
paginate: false
}),
series: {
argumentField: 'fruit',
valueField: 'count'
}
});
});Angular
import { Component } from '@angular/core';
import DataSource from 'devextreme/data/data_source';
@Component({
selector: 'app-root',
templateUrl: './app.component.html',
styleUrls: ['./app.component.css']
})
export class AppComponent {
fruits = [
{ apples: 10 },
{ oranges: 12 },
{ lemons: 15 },
{ pears: 20 },
{ pineapples: 3 }
];
chartDataSource = new DataSource({
store: {
type: 'array',
data: this.fruits
},
map: function (item) {
const fruitName = Object.keys(item)[0];
return {
fruit: fruitName.charAt(0).toUpperCase() + fruitName.slice(1),
count: item[fruitName]
}
},
paginate: false
});
}
<dx-chart [dataSource]="chartDataSource">
<dxi-series argumentField="fruit" valueField="count"></dxi-series>
</dx-chart>
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { AppComponent } from './app.component';
import { DxChartModule } from 'devextreme-angular';
@NgModule({
declarations: [
AppComponent
],
imports: [
BrowserModule,
DxChartModule
],
providers: [ ],
bootstrap: [AppComponent]
})
export class AppModule { }Vue
<template>
<DxChart :data-source="chartDataSource">
<DxSeries argument-field="fruit" value-field="count" />
</DxChart>
</template>
<script>
import DxChart, {
DxSeries
} from 'devextreme-vue/chart';
import DataSource from 'devextreme/data/data_source';
const fruits = [
{ apples: 10 },
{ oranges: 12 },
{ lemons: 15 },
{ pears: 20 },
{ pineapples: 3 }
];
const chartDataSource = new DataSource({
store: {
type: 'array',
data: fruits
},
map: function (item) {
const fruitName = Object.keys(item)[0];
return {
fruit: fruitName.charAt(0).toUpperCase() + fruitName.slice(1),
count: item[fruitName]
}
},
paginate: false
});
export default {
components: {
DxChart,
DxSeries
},
data() {
return {
chartDataSource
}
}
}
</script>React
import Chart, {
Series
} from 'devextreme-react/chart';
import DataSource from 'devextreme/data/data_source';
const fruits = [
{ apples: 10 },
{ oranges: 12 },
{ lemons: 15 },
{ pears: 20 },
{ pineapples: 3 }
];
const chartDataSource = new DataSource({
store: {
type: 'array',
data: fruits
},
map: function (item) {
const fruitName = Object.keys(item)[0];
return {
fruit: fruitName.charAt(0).toUpperCase() + fruitName.slice(1),
count: item[fruitName]
}
},
paginate: false
});
export default function App() {
return (
<Chart dataSource={chartDataSource}>
<Series argumentField="fruit" valueField="count" />
</Chart>
);
}See Also
If you have technical questions, please create a support ticket in the DevExpress Support Center.